
#include <stdio.h>
#include "stdint.h"
#include "ufs_dirio.h"
#include "ufs_fileio.h"
#include "sd.h"

int main()
{

	struct t_file file1, file2;
	uint8_t exampledir1[] = "/dir1";
	uint8_t exampledir2[] = "/dir1/dir2";
	uint8_t examplefile1[] = "/dir1/file.ext";
	uint8_t examplefile2[] = "/dir1/dir2/file2.ext";
	sd_init();
	
	//let us create 2 directorys
	ufs_makedir(exampledir1);
	ufs_remdir(exampledir1);
	ufs_makedir(exampledir2);

	//open a file and write some text in it
	ufs_fopen(&file1, examplefile1, 'w');
	ufs_fputs(&file1, "Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Quisque consectetuer quam vitae nisl. In auctor dui vel mi. Maecenas molestie sem at diam. Ut id lectus et lacus imperdiet imperdiet. Sed nonummy suscipit eros. Cras euismod, sapien quis commodo iaculis, erat odio tempus eros, sit amet tempus nisl odio sed erat. Fusce est eros, sollicitudin at, feugiat in, accumsan ac, lectus. Sed ut odio. Sed varius consectetuer libero. Nulla vitae ipsum blandit magna tincidunt tempus. Mauris vulputate viverra orci. Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Sed sed tortor. Donec nec turpis. Vivamus quis dui at eros vestibulum lacinia. Nullam mi. Integer pulvinar lacus. Quisque arcu enim, ultricies sed, semper a, vulputate nec, odio. Morbi scelerisque lorem at justo tempor pretium." \
					  "In diam. Aliquam elementum porttitor ligula. Vestibulum id est. Proin blandit elementum nisi. In est arcu, varius sed, porttitor at, pretium et, tortor. Aenean viverra, eros non tincidunt placerat, pede nunc euismod leo metus.");
	ufs_fclose(&file1);

	//print / and /dir1
	ufs_printdir("/");
	ufs_printdir("/dir1");

	//open file1 again and read the text to put on console.
	ufs_fopen(&file1, examplefile1, 'r');
	while (!ufs_feof(&file1))
		printf("%c", ufs_fgetc(&file1));
	ufs_fclose(&file1);

	//open a second file and put some different text in it.
	ufs_fopen(&file2, examplefile2, 'w');
	ufs_fputs(&file2, " This string will be appended.");
	ufs_fclose(&file2);

	//open both files and append the content of file2 to file1
	ufs_fopen(&file1, examplefile1, 'a');
	ufs_fopen(&file2, examplefile2, 'r');

	while(!ufs_feof(&file2))
		ufs_fputc(&file1, ufs_fgetc(&file2));

	ufs_fclose(&file1);
	ufs_fclose(&file2);

	//now print file1 again
	printf("\n");
	ufs_fopen(&file1, examplefile1, 'r');
	while(!ufs_feof(&file1))
		printf("%c", ufs_fgetc(&file1));
	ufs_fclose(&file1);

	//print /dir1 again to look at the filesize
	printf("\n");	
	ufs_printdir("/dir1");

	//look if file2 is created in dir2
	ufs_printdir("/dir1/dir2");

	//open file1 and replace the first word "Lorem" with "meroL"
	ufs_fopen(&file1, examplefile1, 'r');
	ufs_fputs(&file1, "meroL");
	ufs_fclose(&file1);

	//print file1 again on screen
	printf("\n");
	ufs_fopen(&file1, examplefile1, 'r');
	while (!ufs_feof(&file1))
		printf("%c", ufs_fgetc(&file1));
	ufs_fclose(&file1);

	//and print dir1 with file1 to look at filesize of file1. should NOT have changed
	printf("\n");
	ufs_printdir("/dir1");


	return 0;
}