/* 
   [time.h]
   (c) Simon Kueppers
   20.12.06 Germany

   In this file are simple time getting/setting/converting function prototypes
   

   PS:
   I tried to comment the code as best as i was able to. This is a little bit confusing
   for a german, so please excuse if something is not that right it should be.
   Have fun with this code but remember the BEER LICENSE when you copy+paste something
   from here :-)

*/

#ifndef _time
#define _time

#include "stdint.h"									//Vartypedefs

#define GMT	3600									//time offset from GMT

struct t_time
{
	uint16_t year;					
	uint8_t month;				
	uint8_t day;					
	uint8_t hour;					
	uint8_t minute;				
	uint8_t second;				
};

/*
   This function lets you get the current time from everywhere else

   return: current time as timestamp
*/
uint32_t gettime ();

/*
   This function lets you set the current time from everywhere else

   seconds: timestamp of time to set
   return: no return value
*/
void settime (uint32_t seconds);

/*
   Use this function to convert the a timestamp (for example
   the currenttime) to a more readable struct t_time.

   sec: timestamp of time to convert
   time: pointer to a time-struct with more readable data
   return: no return value
*/
void convtime	(uint32_t sec, struct t_time* time);

/*
   This function should be called every second to get a stable 
   RTC base. (Use a timer or something like that)

   return: no return value
*/
void rtc_irq ();	


#endif //_time